# 4 obs
logl_twoz_twozs = function(para, z1, z2, z1_star, z2_star,
                            des_mat, des_mat_delta,
                            des_mat_sens, des_mat_spec) {
  l_beta = ncol(des_mat)
  l_gamma = ncol(des_mat_delta)
  l_gamma_sens = ncol(des_mat_sens)
  l_gamma_spec = ncol(des_mat_spec)

  beta = para[1:l_beta]
  gamma = para[(l_beta + 1):(l_beta + l_gamma)]
  gamma_sens = para[(l_beta + l_gamma + 1):(l_beta + l_gamma + l_gamma_sens)]
  gamma_spec = para[(l_beta + l_gamma + l_gamma_sens + 1):(l_beta + l_gamma +
    l_gamma_sens + l_gamma_spec)]
  pi = plogis(des_mat %*% beta)
  delta = plogis(des_mat_delta %*% gamma)
  sens = plogis(des_mat_sens %*% gamma_sens)
  spec = plogis(des_mat_spec %*% gamma_spec)
  loglik_pp = z1 * z2 * z1_star * z2_star * log(sens^2 * delta * pi) +
    (z1 * z2 * z1_star * (1 - z2_star) + z1 * z2 * (1 - z1_star) * z2_star) *
      log((1 - sens) * sens * delta * pi) +
    z1 * z2 * (1 - z1_star) * (1 - z2_star) * log((1 - sens)^2 * delta * pi) +
    (1 - z1) * (1 - z2) * (1 - z1_star) * (1 - z2_star) * log(spec^2 * (1 - pi)) +
    ((1 - z1) * (1 - z2) * z1_star * (1 - z2_star) + (1 - z1) * (1 - z2) * (1 - z1_star) * z2_star) *
      log(spec * (1 - spec) * (1 - pi)) +
    (1 - z1) * (1 - z2) * z1_star * z2_star * log((1 - spec)^2 * (1 - pi)) +
    ((1 - z1) * z2 * (1 - z1_star) * (1 - z2_star) + z1 * (1 - z2) * (1 - z1_star) * (1 - z2_star)) *
      log(spec * (1 - sens) * (1/2 - 1/2 * delta) * pi) +
    (z1 * (1 - z2) * z1_star * (1 - z2_star) + (1 - z1) * z2 * (1 - z1_star) * z2_star) *
      log(sens * spec * (1/2 - 1/2 * delta) * pi) +
    (z1 * (1 - z2) * (1 - z1_star) * z2_star + (1 - z1) * z2 * z1_star * (1 - z2_star)) *
      log((1 - sens) * (1 - spec) * (1/2 - 1/2 * delta) * pi) +
    (z1 * (1 - z2) * z1_star * z2_star + (1 - z1) * z2 * z1_star * z2_star) *
      log((1 - spec) * sens * (1/2 - 1/2 * delta) * pi)
  sum(loglik_pp)
}

# 3 obs
loglik_z2mis_twozs = function(para, z1, z1_star, z2_star,
                               des_mat, des_mat_delta,
                               des_mat_sens, des_mat_spec) {
  l_beta = ncol(des_mat)
  l_gamma = ncol(des_mat_delta)
  l_gamma_sens = ncol(des_mat_sens)
  l_gamma_spec = ncol(des_mat_spec)

  beta = para[1:l_beta]
  gamma = para[(l_beta + 1):(l_beta + l_gamma)]
  gamma_sens = para[(l_beta + l_gamma + 1):(l_beta + l_gamma + l_gamma_sens)]
  gamma_spec = para[(l_beta + l_gamma + l_gamma_sens + 1):(l_beta + l_gamma +
    l_gamma_sens + l_gamma_spec)]
  pi = plogis(des_mat %*% beta)
  delta = plogis(des_mat_delta %*% gamma)
  sens = plogis(des_mat_sens %*% gamma_sens)
  spec = plogis(des_mat_spec %*% gamma_spec)

  loglik_pp = z1_star * z2_star * z1 *
    log(sens^2 * delta * pi + sens * (1 - spec) * (1/2 - 1/2 * delta) * pi) +
    (1 - z1_star) * z2_star * z1 *
      log((1 - sens) * sens * delta * pi + (1 - sens) * (1 - spec) * (1/2 - 1/2 * delta) * pi) +
    z1_star * (1 - z2_star) * z1 *
      log(sens * (1 - sens) * delta * pi + sens * spec * (1/2 - 1/2 * delta) * pi) +
    (1 - z1_star) * (1 - z2_star) * z1 *
      log((1 - sens)^2 * delta * pi + (1 - sens) * spec * (1/2 - 1/2 * delta) * pi) +
    z1_star * z2_star * (1 - z1) *
      log((1 - spec) * sens * (1/2 - 1/2 * delta) * pi + (1 - spec)^2 * (1 - pi)) +
    (1 - z1_star) * z2_star * (1 - z1) *
      log(spec * sens * (1/2 - 1/2 * delta) * pi + spec * (1 - spec) * (1 - pi)) +
    z1_star * (1 - z2_star) * (1 - z1) *
      log((1 - spec) * (1 - sens) * (1/2 - 1/2 * delta) * pi + (1 - spec) * spec * (1 - pi)) +
    (1 - z1_star) * (1 - z2_star) * (1 - z1) *
      log(spec * (1 - sens) * (1/2 - 1/2 * delta) * pi + spec^2 * (1 - pi))
  sum(loglik_pp)
}

loglik_z1mis_twozs = function(para, z2, z1_star, z2_star,
                               des_mat, des_mat_delta,
                               des_mat_sens, des_mat_spec) {
  l_beta = ncol(des_mat)
  l_gamma = ncol(des_mat_delta)
  l_gamma_sens = ncol(des_mat_sens)
  l_gamma_spec = ncol(des_mat_spec)

  beta = para[1:l_beta]
  gamma = para[(l_beta + 1):(l_beta + l_gamma)]
  gamma_sens = para[(l_beta + l_gamma + 1):(l_beta + l_gamma + l_gamma_sens)]
  gamma_spec = para[(l_beta + l_gamma + l_gamma_sens + 1):(l_beta + l_gamma +
    l_gamma_sens + l_gamma_spec)]
  pi = plogis(des_mat %*% beta)
  delta = plogis(des_mat_delta %*% gamma)
  sens = plogis(des_mat_sens %*% gamma_sens)
  spec = plogis(des_mat_spec %*% gamma_spec)

  loglik_pp = z1_star * z2_star * z2 *
    log(sens^2 * delta * pi + sens * (1 - spec) * (1/2 - 1/2 * delta) * pi) +
    z1_star * (1 - z2_star) * z2 *
      log((1 - sens) * sens * delta * pi + (1 - sens) * (1 - spec) * (1/2 - 1/2 * delta) * pi) +
    (1 - z1_star) * z2_star * z2 *
      log(sens * (1 - sens) * delta * pi + sens * spec * (1/2 - 1/2 * delta) * pi) +
    (1 - z1_star) * (1 - z2_star) * z2 *
      log((1 - sens)^2 * delta * pi + (1 - sens) * spec * (1/2 - 1/2 * delta) * pi) +
    z1_star * z2_star * (1 - z2) *
      log((1 - spec) * sens * (1/2 - 1/2 * delta) * pi + (1 - spec)^2 * (1 - pi)) +
    z1_star * (1 - z2_star) * (1 - z2) *
      log(spec * sens * (1/2 - 1/2 * delta) * pi + spec * (1 - spec) * (1 - pi)) +
    (1 - z1_star) * z2_star * (1 - z2) *
      log((1 - spec) * (1 - sens) * (1/2 - 1/2 * delta) * pi + (1 - spec) * spec * (1 - pi)) +
    (1 - z1_star) * (1 - z2_star) * (1 - z2) *
      log(spec * (1 - sens) * (1/2 - 1/2 * delta) * pi + spec^2 * (1 - pi))
  sum(loglik_pp)
}

loglik_twoz_z2smis = function(para, z1, z2, z1_star,
                               des_mat, des_mat_delta,
                               des_mat_sens, des_mat_spec) {
  l_beta = ncol(des_mat)
  l_gamma = ncol(des_mat_delta)
  l_gamma_sens = ncol(des_mat_sens)
  l_gamma_spec = ncol(des_mat_spec)

  beta = para[1:l_beta]
  gamma = para[(l_beta + 1):(l_beta + l_gamma)]
  gamma_sens = para[(l_beta + l_gamma + 1):(l_beta + l_gamma + l_gamma_sens)]
  gamma_spec = para[(l_beta + l_gamma + l_gamma_sens + 1):(l_beta + l_gamma +
    l_gamma_sens + l_gamma_spec)]
  pi = plogis(des_mat %*% beta)
  delta = plogis(des_mat_delta %*% gamma)
  sens = plogis(des_mat_sens %*% gamma_sens)
  spec = plogis(des_mat_spec %*% gamma_spec)

  loglik_pp = z1 * z2 * z1_star * log(sens * delta * pi) +
    z1 * z2 * (1 - z1_star) * log((1 - sens) * delta * pi) +
    z1 * (1 - z2) * z1_star * log(sens * (1/2 - 1/2 * delta) * pi) +
    z1 * (1 - z2) * (1 - z1_star) * log((1 - sens) * (1/2 - 1/2 * delta) * pi) +
    (1 - z1) * z2 * z1_star * log((1 - spec) * (1/2 - 1/2 * delta) * pi) +
    (1 - z1) * z2 * (1 - z1_star) * log(spec * (1/2 - 1/2 * delta) * pi) +
    (1 - z1) * (1 - z2) * z1_star * log((1 - spec) * (1 - pi)) +
    (1 - z1) * (1 - z2) * (1 - z1_star) * log(spec * (1 - pi))

  sum(loglik_pp)
}

loglik_twoz_z1smis = function(para, z1, z2, z2_star,
                               des_mat, des_mat_delta,
                               des_mat_sens, des_mat_spec) {
  l_beta = ncol(des_mat)
  l_gamma = ncol(des_mat_delta)
  l_gamma_sens = ncol(des_mat_sens)
  l_gamma_spec = ncol(des_mat_spec)

  beta = para[1:l_beta]
  gamma = para[(l_beta + 1):(l_beta + l_gamma)]
  gamma_sens = para[(l_beta + l_gamma + 1):(l_beta + l_gamma + l_gamma_sens)]
  gamma_spec = para[(l_beta + l_gamma + l_gamma_sens + 1):(l_beta + l_gamma +
    l_gamma_sens + l_gamma_spec)]
  pi = plogis(des_mat %*% beta)
  delta = plogis(des_mat_delta %*% gamma)
  sens = plogis(des_mat_sens %*% gamma_sens)
  spec = plogis(des_mat_spec %*% gamma_spec)

  loglik_pp = z1 * z2 * z2_star * log(sens * delta * pi) +
    z1 * z2 * (1 - z2_star) * log((1 - sens) * delta * pi) +
    z1 * (1 - z2) * z2_star * log((1 - spec) * (1/2 - 1/2 * delta) * pi) +
    z1 * (1 - z2) * (1 - z2_star) * log(spec * (1/2 - 1/2 * delta) * pi) +
    (1 - z1) * z2 * z2_star * log(sens * (1/2 - 1/2 * delta) * pi) +
    (1 - z1) * z2 * (1 - z2_star) * log((1 - sens) * (1/2 - 1/2 * delta) * pi) +
    (1 - z1) * (1 - z2) * z2_star * log((1 - spec) * (1 - pi)) +
    (1 - z1) * (1 - z2) * (1 - z2_star) * log(spec * (1 - pi))

  sum(loglik_pp)
}

# 2 obs
logl_noz_twozs = function(para, z1_star, z2_star,
                           des_mat, des_mat_delta,
                           des_mat_sens, des_mat_spec) {
  l_beta = ncol(des_mat)
  l_gamma = ncol(des_mat_delta)
  l_gamma_sens = ncol(des_mat_sens)
  l_gamma_spec = ncol(des_mat_spec)

  beta = para[1:l_beta]
  gamma = para[(l_beta + 1):(l_beta + l_gamma)]
  gamma_sens = para[(l_beta + l_gamma + 1):(l_beta + l_gamma + l_gamma_sens)]
  gamma_spec = para[(l_beta + l_gamma + l_gamma_sens + 1):(l_beta + l_gamma +
    l_gamma_sens + l_gamma_spec)]
  pi = plogis(des_mat %*% beta)
  delta = plogis(des_mat_delta %*% gamma)
  sens = plogis(des_mat_sens %*% gamma_sens)
  spec = plogis(des_mat_spec %*% gamma_spec)

  loglik_pp = z1_star * z2_star *
    log((1 - spec)^2 + ((1 - spec) * sens * (1 - delta) +
      sens^2 * delta -
      (1 - spec)^2) * pi) +
    ((1 - z1_star) * z2_star + z1_star * (1 - z2_star)) *
      log(spec * (1 - spec) + ((1 + 2 * sens * spec - sens - spec) * (1/2 - 1/2 * delta) +
        sens * (1 - sens) * delta -
        spec * (1 - spec)) * pi) +
    (1 - z1_star) * (1 - z2_star) *
      log(spec^2 + ((1 - sens) * spec * (1 - delta) + (1 - sens)^2 * delta - spec^2) * pi)
  sum(loglik_pp)
}

logl_twoz_nozs = function(para, z1, z2,
                           des_mat, des_mat_delta,
                           des_mat_sens, des_mat_spec) {
  l_beta = ncol(des_mat)
  l_gamma = ncol(des_mat_delta)
  l_gamma_sens = ncol(des_mat_sens)
  l_gamma_spec = ncol(des_mat_spec)

  beta = para[1:l_beta]
  gamma = para[(l_beta + 1):(l_beta + l_gamma)]
  gamma_sens = para[(l_beta + l_gamma + 1):(l_beta + l_gamma + l_gamma_sens)]
  gamma_spec = para[(l_beta + l_gamma + l_gamma_sens + 1):(l_beta + l_gamma +
    l_gamma_sens + l_gamma_spec)]
  pi = plogis(des_mat %*% beta)
  delta = plogis(des_mat_delta %*% gamma)
  sens = plogis(des_mat_sens %*% gamma_sens)
  spec = plogis(des_mat_spec %*% gamma_spec)

  loglik_pp = z1 * z2 * log(delta * pi) +
    ((1 - z1) * z2 + z1 * (1 - z2)) * log((1/2 - 1/2 * delta) * pi) +
    (1 - z1) * (1 - z2) * log(1 - pi)
  sum(loglik_pp)
}

logl_onez_onezs_same = function(para, z, zs,
                                 des_mat, des_mat_delta,
                                 des_mat_sens, des_mat_spec) {
  l_beta = ncol(des_mat)
  l_gamma = ncol(des_mat_delta)
  l_gamma_sens = ncol(des_mat_sens)
  l_gamma_spec = ncol(des_mat_spec)

  beta = para[1:l_beta]
  gamma = para[(l_beta + 1):(l_beta + l_gamma)]
  gamma_sens = para[(l_beta + l_gamma + 1):(l_beta + l_gamma + l_gamma_sens)]
  gamma_spec = para[(l_beta + l_gamma + l_gamma_sens + 1):(l_beta + l_gamma +
    l_gamma_sens + l_gamma_spec)]
  pi = plogis(des_mat %*% beta)
  delta = plogis(des_mat_delta %*% gamma)
  sens = plogis(des_mat_sens %*% gamma_sens)
  spec = plogis(des_mat_spec %*% gamma_spec)

  loglik_pp = z * zs * log(sens * (1/2 + 1/2 * delta) * pi) +
    z * (1 - zs) * log((1 - sens) * (1/2 + 1/2 * delta) * pi) +
    (1 - z) * zs * log((1 - spec) * (1 - (1/2 + 1/2 * delta) * pi)) +
    (1 - z) * (1 - zs) * log(spec * (1 - (1/2 + 1/2 * delta) * pi))
  sum(loglik_pp)
}

logl_onez_onezs_diff = function(para, z, zs,
                                 des_mat, des_mat_delta,
                                 des_mat_sens, des_mat_spec) {
  l_beta = ncol(des_mat)
  l_gamma = ncol(des_mat_delta)
  l_gamma_sens = ncol(des_mat_sens)
  l_gamma_spec = ncol(des_mat_spec)

  beta = para[1:l_beta]
  gamma = para[(l_beta + 1):(l_beta + l_gamma)]
  gamma_sens = para[(l_beta + l_gamma + 1):(l_beta + l_gamma + l_gamma_sens)]
  gamma_spec = para[(l_beta + l_gamma + l_gamma_sens + 1):(l_beta + l_gamma +
    l_gamma_sens + l_gamma_spec)]
  pi = plogis(des_mat %*% beta)
  delta = plogis(des_mat_delta %*% gamma)
  sens = plogis(des_mat_sens %*% gamma_sens)
  spec = plogis(des_mat_spec %*% gamma_spec)

  loglik_pp = z * zs * log(sens * delta * pi + (1 - spec) * (1/2 - 1/2 * delta) * pi) +
    z * (1 - zs) * log((1 - sens) * delta * pi + (spec) * (1/2 - 1/2 * delta) * pi) +
    (1 - z) * zs * log(sens * (1/2 - 1/2 * delta) * pi + (1 - spec) * (1 - pi)) +
    (1 - z) * (1 - zs) * log((1 - sens) * (1/2 - 1/2 * delta) * pi + spec * (1 - pi))
  sum(loglik_pp)
}

## 1 obs
logl_onez_nozs = function(para, z,
                           des_mat, des_mat_delta,
                           des_mat_sens, des_mat_spec) {
  l_beta = ncol(des_mat)
  l_gamma = ncol(des_mat_delta)
  l_gamma_sens = ncol(des_mat_sens)
  l_gamma_spec = ncol(des_mat_spec)

  beta = para[1:l_beta]
  gamma = para[(l_beta + 1):(l_beta + l_gamma)]
  gamma_sens = para[(l_beta + l_gamma + 1):(l_beta + l_gamma + l_gamma_sens)]
  gamma_spec = para[(l_beta + l_gamma + l_gamma_sens + 1):(l_beta + l_gamma +
    l_gamma_sens + l_gamma_spec)]
  pi = plogis(des_mat %*% beta)
  delta = plogis(des_mat_delta %*% gamma)
  sens = plogis(des_mat_sens %*% gamma_sens)
  spec = plogis(des_mat_spec %*% gamma_spec)

  loglik_pp = z * log((1/2 + 1/2 * delta) * pi) +
    (1 - z) * log(1 - (1/2 + 1/2 * delta) * pi)
  sum(loglik_pp)
}

logl_noz_onezs = function(para, zs,
                           des_mat, des_mat_delta,
                           des_mat_sens, des_mat_spec) {
  l_beta = ncol(des_mat)
  l_gamma = ncol(des_mat_delta)
  l_gamma_sens = ncol(des_mat_sens)
  l_gamma_spec = ncol(des_mat_spec)

  beta = para[1:l_beta]
  gamma = para[(l_beta + 1):(l_beta + l_gamma)]
  gamma_sens = para[(l_beta + l_gamma + 1):(l_beta + l_gamma + l_gamma_sens)]
  gamma_spec = para[(l_beta + l_gamma + l_gamma_sens + 1):(l_beta + l_gamma +
    l_gamma_sens + l_gamma_spec)]
  pi = plogis(des_mat %*% beta)
  delta = plogis(des_mat_delta %*% gamma)
  sens = plogis(des_mat_sens %*% gamma_sens)
  spec = plogis(des_mat_spec %*% gamma_spec)

  loglik_pp = zs * log((1 - spec) + (sens + spec - 1) * (1/2 + 1/2 * delta) * pi) +
    (1 - zs) * log(spec + (1 - sens - spec) * (1/2 + 1/2 * delta) * pi)
  sum(loglik_pp)
}


#' Negative Log-likelihood of logistic regression for bilateral data
#'
#' Negative Log-likelihood function
#'
#' @param para vector of parameters to estimate, first k=ncol(des_mat) entries are
#' are coefficients of the k covariates of the logistic regression model of the
#' worse-entity disease (beta_0, ..., beta_k), the following l=ncol(des_mat_delta) entries
#' the coefficients of the logistic regression model for modelling the
#' conditional probability of disease in both entities given disease in at
#' least one entity, delta (gamma_0, ..., gamma_l); and the following m=ncol(des_mat_sens)
#' and n=ncol(des_mat_spec) are coefficients of the logistic regression model for sensitivity
#' and specificity, respectively.
#' @param z1 vector of true binary response for first entity (zero or one when available, NA when missing)
#' @param z2 vector of true binary response for second entity (zero or one when available, NA when missing)
#' @param z1_star vector of error-prone binary response for first entity (zero or one when available, NA when missing)
#' @param z2_star vector of error-prone binary response for second entity (zero or one when available, NA when missing)
#' @param des_mat design matrix of logistic regression model for worse-entity response
#' @param des_mat_delta design matrix of logistic regression model for delta
#' @param des_mat_sens design matrix of logistic regression model for sensitivity
#' @param des_mat_spec design matrix of logistic regression model for specificity
#' @importFrom stats plogis

neg_loglik = function(para, z1, z2, z1_star, z2_star,
                       des_mat, des_mat_delta, des_mat_sens, des_mat_spec) {
  which_full = which(!is.na(z1) & !is.na(z2) & !is.na(z1_star) & !is.na(z2_star))
  which_z2mis_twozs = which(!is.na(z1) & is.na(z2) &
    !is.na(z1_star) & !is.na(z2_star))
  which_z1mis_twozs = which(is.na(z1) & !is.na(z2) &
    !is.na(z1_star) & !is.na(z2_star))
  which_twoz_z2smis = which(!is.na(z1) & !is.na(z2) &
    !is.na(z1_star) & is.na(z2_star))
  which_twoz_z1smis = which(!is.na(z1) & !is.na(z2) &
    is.na(z1_star) & !is.na(z2_star))
  which_noz_twozs = which(is.na(z1) & is.na(z2) &
    !is.na(z1_star) & !is.na(z2_star))
  which_twoz_nozs = which(!is.na(z1) & !is.na(z2) &
    is.na(z1_star) & is.na(z2_star))
  which_onez_onezs_diff = which(is.na(z1) & !is.na(z2) &
    !is.na(z1_star) & is.na(z2_star) |
    !is.na(z1) & is.na(z2) &
      is.na(z1_star) & !is.na(z2_star))
  which_onez_onezs_same = which(is.na(z1) & !is.na(z2) &
    is.na(z1_star) & !is.na(z2_star) |
    !is.na(z1) & is.na(z2) &
      !is.na(z1_star) & is.na(z2_star))
  which_onez_nozs = which(is.na(z1) & !is.na(z2) &
    is.na(z1_star) & is.na(z2_star) |
    !is.na(z1) & is.na(z2) &
      is.na(z1_star) & is.na(z2_star))
  which_noz_onezs = which(is.na(z1) & is.na(z2) &
    !is.na(z1_star) & is.na(z2_star) |
    is.na(z1) & is.na(z2) &
      is.na(z1_star) & !is.na(z2_star))

  neg_loglik = - # 4 obs
    logl_twoz_twozs(para,
      z1 = z1[which_full],
      z2 = z2[which_full],
      z1_star = z1_star[which_full],
      z2_star = z2_star[which_full],
      des_mat = des_mat[which_full, , drop = FALSE],
      des_mat_delta = des_mat_delta[which_full, , drop = FALSE],
      des_mat_sens = des_mat_sens[which_full, , drop = FALSE],
      des_mat_spec = des_mat_spec[which_full, , drop = FALSE]
    ) -
    # 3 obs
    loglik_z1mis_twozs(para,
      z2 = z2[which_z1mis_twozs],
      z1_star = z1_star[which_z1mis_twozs],
      z2_star = z2_star[which_z1mis_twozs],
      des_mat = des_mat[which_z1mis_twozs, , drop = FALSE],
      des_mat_delta = des_mat_delta[which_z1mis_twozs, , drop = FALSE],
      des_mat_sens = des_mat_sens[which_z1mis_twozs, , drop = FALSE],
      des_mat_spec = des_mat_spec[which_z1mis_twozs, , drop = FALSE]
    ) -
    loglik_z2mis_twozs(para,
      z1 = z1[which_z2mis_twozs],
      z1_star = z1_star[which_z2mis_twozs],
      z2_star = z2_star[which_z2mis_twozs],
      des_mat = des_mat[which_z2mis_twozs, , drop = FALSE],
      des_mat_delta = des_mat_delta[which_z2mis_twozs, , drop = FALSE],
      des_mat_sens = des_mat_sens[which_z2mis_twozs, , drop = FALSE],
      des_mat_spec = des_mat_spec[which_z2mis_twozs, , drop = FALSE]
    ) -
    loglik_twoz_z1smis(para,
      z1 = z1[which_twoz_z1smis],
      z2 = z2[which_twoz_z1smis],
      z2_star = z2_star[which_twoz_z1smis],
      des_mat = des_mat[which_twoz_z1smis, , drop = FALSE],
      des_mat_delta = des_mat_delta[which_twoz_z1smis, , drop = FALSE],
      des_mat_sens = des_mat_sens[which_twoz_z1smis, , drop = FALSE],
      des_mat_spec = des_mat_spec[which_twoz_z1smis, , drop = FALSE]
    ) -
    loglik_twoz_z2smis(para,
      z1 = z1[which_twoz_z2smis],
      z2 = z2[which_twoz_z2smis],
      z1_star = z1_star[which_twoz_z2smis],
      des_mat = des_mat[which_twoz_z2smis, , drop = FALSE],
      des_mat_delta = des_mat_delta[which_twoz_z2smis, , drop = FALSE],
      des_mat_sens = des_mat_sens[which_twoz_z2smis, , drop = FALSE],
      des_mat_spec = des_mat_spec[which_twoz_z2smis, , drop = FALSE]
    ) -
    # 2 obs
    logl_noz_twozs(para,
      z1_star = z1_star[which_noz_twozs],
      z2_star = z2_star[which_noz_twozs],
      des_mat = des_mat[which_noz_twozs, , drop = FALSE],
      des_mat_delta = des_mat_delta[which_noz_twozs, , drop = FALSE],
      des_mat_sens = des_mat_sens[which_noz_twozs, , drop = FALSE],
      des_mat_spec = des_mat_spec[which_noz_twozs, , drop = FALSE]
    ) -
    logl_twoz_nozs(para,
      z1 = z1[which_twoz_nozs],
      z2 = z2[which_twoz_nozs],
      des_mat = des_mat[which_twoz_nozs, , drop = FALSE],
      des_mat_delta = des_mat_delta[which_twoz_nozs, , drop = FALSE],
      des_mat_sens = des_mat_sens[which_twoz_nozs, , drop = FALSE],
      des_mat_spec = des_mat_spec[which_twoz_nozs, , drop = FALSE]
    ) -
    logl_onez_onezs_diff(para,
      z = ifelse(is.na(z1[which_onez_onezs_diff]),
        z2[which_onez_onezs_diff],
        z1[which_onez_onezs_diff]
      ),
      zs = ifelse(is.na(z1_star[which_onez_onezs_diff]),
        z2_star[which_onez_onezs_diff],
        z1_star[which_onez_onezs_diff]
      ),
      des_mat = des_mat[which_onez_onezs_diff, , drop = FALSE],
      des_mat_delta = des_mat_delta[which_onez_onezs_diff, , drop = FALSE],
      des_mat_sens = des_mat_sens[which_onez_onezs_diff, , drop = FALSE],
      des_mat_spec = des_mat_spec[which_onez_onezs_diff, , drop = FALSE]
    ) -
    logl_onez_onezs_same(para,
      z = ifelse(is.na(z1[which_onez_onezs_same]),
        z2[which_onez_onezs_same],
        z1[which_onez_onezs_same]
      ),
      zs = ifelse(is.na(z1_star[which_onez_onezs_same]),
        z2_star[which_onez_onezs_same],
        z1_star[which_onez_onezs_same]
      ),
      des_mat = des_mat[which_onez_onezs_same, , drop = FALSE],
      des_mat_delta = des_mat_delta[which_onez_onezs_same, , drop = FALSE],
      des_mat_sens = des_mat_sens[which_onez_onezs_same, , drop = FALSE],
      des_mat_spec = des_mat_spec[which_onez_onezs_same, , drop = FALSE]
    ) -
    # one obs
    logl_onez_nozs(para,
      z = ifelse(is.na(z1[which_onez_nozs]),
        z2[which_onez_nozs], z1[which_onez_nozs]
      ),
      des_mat = des_mat[which_onez_nozs, , drop = FALSE],
      des_mat_delta = des_mat_delta[which_onez_nozs, , drop = FALSE],
      des_mat_sens = des_mat_sens[which_onez_nozs, , drop = FALSE],
      des_mat_spec = des_mat_spec[which_onez_nozs, , drop = FALSE]
    ) -
    logl_noz_onezs(para,
      zs = ifelse(is.na(z1_star[which_noz_onezs]),
        z2_star[which_noz_onezs], z1_star[which_noz_onezs]
      ),
      des_mat = des_mat[which_noz_onezs, , drop = FALSE],
      des_mat_delta = des_mat_delta[which_noz_onezs, , drop = FALSE],
      des_mat_sens = des_mat_sens[which_noz_onezs, , drop = FALSE],
      des_mat_spec = des_mat_spec[which_noz_onezs, , drop = FALSE]
    )
  neg_loglik
}
