% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/likelihood.R
\name{neg_loglik}
\alias{neg_loglik}
\title{Negative Log-likelihood of logistic regression for bilateral data}
\usage{
neg_loglik(
  para,
  z1,
  z2,
  z1_star,
  z2_star,
  des_mat,
  des_mat_delta,
  des_mat_sens,
  des_mat_spec
)
}
\arguments{
\item{para}{vector of parameters to estimate, first k=ncol(des_mat) entries are
are coefficients of the k covariates of the logistic regression model of the
worse-entity disease (beta_0, ..., beta_k), the following l=ncol(des_mat_delta) entries
the coefficients of the logistic regression model for modelling the
conditional probability of disease in both entities given disease in at
least one entity, delta (gamma_0, ..., gamma_l); and the following m=ncol(des_mat_sens)
and n=ncol(des_mat_spec) are coefficients of the logistic regression model for sensitivity
and specificity, respectively.}

\item{z1}{vector of true binary response for first entity (zero or one when available, NA when missing)}

\item{z2}{vector of true binary response for second entity (zero or one when available, NA when missing)}

\item{z1_star}{vector of error-prone binary response for first entity (zero or one when available, NA when missing)}

\item{z2_star}{vector of error-prone binary response for second entity (zero or one when available, NA when missing)}

\item{des_mat}{design matrix of logistic regression model for worse-entity response}

\item{des_mat_delta}{design matrix of logistic regression model for delta}

\item{des_mat_sens}{design matrix of logistic regression model for sensitivity}

\item{des_mat_spec}{design matrix of logistic regression model for specificity}
}
\description{
Negative Log-likelihood function
}
