context("likelihood-optim")

n = 500
delta = .75
x1 = rnorm(n, 0, 1)
y = rbinom(n, 1, plogis(x1))
which.y1 = which(y==1)
which.y0 = which(y==0)

z1 = rep(NA, 500)
z2 = rep(NA, 500)

z1[which.y0] = 0
z2[which.y0] = 0

both = which.y1[rbinom(length(which.y1), 1, delta)==1]

z1[both] = 1
z2[both] = 1

one = which(is.na(z1))
one.1 = sample(one, size = floor(length(one)/2), replace = FALSE)
one.2 = setdiff(one, one.1)

z1[one.1] = 1
z2[one.1] = 0

z1[one.2] = 0
z2[one.2] = 1

z1_star = z1
z2_star = z2


z1_star2 = rbinom(500,1,.5)
z2_star2 = rbinom(500,1,.5)

res.log = summary(glm(y~x1, family = "binomial"))$coef
res.billog = est_mcblog(z1=z1, z2=z2, z1_star = z1_star, z2_star = z2_star,
          formula = ~x1,
          formula_delta = ~x1,
          formula_sens =  ~1,
          formula_spec = ~1,
          data = data.frame(x1))[[1]]

res.billog2 = est_mcblog(z1=z1, z2=z2, z1_star = z1_star2, z2_star = z2_star2,
                     formula = ~x1,
                     formula_delta = ~x1,
                     formula_sens =  ~1,
                     formula_spec = ~1,
                     data = data.frame(x1))[[1]]

expect_equivalent(as.matrix(round(res.billog[1:2,],2)), as.matrix(round(res.log, 2)))
expect_equivalent(as.matrix(round(res.billog2[1:2,],2)), as.matrix(round(res.log, 2)))
